/*
	DSerial Bootloader v1.0
	Copyright (C) 2006 Alexei Karpenko

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include <c8051f320.h>

//-----------------------------------------------------------------------------
// Defines
//-----------------------------------------------------------------------------

#define FIRMWARE_OFFSET			0x0800

#define TRUE			1
#define FALSE			0

#define Led0			P1_0
#define Led1			P1_1
#define DsIrq			P3_0

#define UartTx			P0_4
#define UartRx			P0_5
#define UartEn			P0_6




#define MAX_DATA_SIZE	32

#define BUFFER_EMPTY	0
#define BUFFER_FILLING	1
#define BUFFER_READY	2





#define SELECT_READ				0x00
#define SELECT_WRITE			0x80
#define SELECT_INTERRUPT		0x01
#define SELECT_CHECK			0x9F

#define SELECT_FLASH			0x02
#define SELECT_FLASH_ERASE		0x03
#define SELECT_BOOT_FIRMWARE	0x04
#define SELECT_BOOT_LOADER		0x05

#define SELECT_UART_BAUD		0x10
#define SELECT_UART_BUFFER		0x11


#define INTERRUPT_BOOTLOADER	0x01
#define INTERRUPT_UART_SENT		0x02
#define INTERRUPT_UART_RECEIVED	0x04
#define INTERRUPT_IO			0x08
#define INTERRUPT_ADC			0x10
#define INTERRUPT_PWM			0x20
#define INTERRUPT_USB			0x40


typedef struct {
	unsigned char size;
	unsigned char curr;
	unsigned char d[32];
} t_buffer;

typedef struct {
	unsigned char read;
	unsigned char write;
	unsigned char d[32];
} t_circular;

typedef struct {
	unsigned char size;
	unsigned int  dest;
	unsigned char d[32];
} t_fw_buffer;

